import matplotlib.pyplot as plt
import numpy as np
from sklearn.model_selection import train_test_split
from sklearn import tree
from sklearn import metrics

#read fiche .csv

import pandas as pd
data = pd.read_csv('data.csv', sep= ';')
Temperature=data['Tin']

labelcopy= []
for k in range (len(data['label'])):
    if ((type(data['label'])) != k):
        if (data['label'][k] <=0.5):
            labelcopy.append(0)
        else:
            labelcopy.append(1)

data['labelcopy']=labelcopy
print(data)
    
for k in range(len(data['power'])):
    if data['power'][k] ==0 and data['office_CO2_concentration'][k] < 400 and data['CO2_corridor'][k]<400:
        print("There's no one")
    elif data['power'][k] > 0:
        if data['Door'][k]!=0:
            print("There’s at least one person")
        if data['acoustic_pressure_dB'][k]!=0:
            print("There’s at least one person")


# Train_test_split

xtrain, x_test, y_train, y_test = train_test_split (
    data[["Tin","Tout", "humidity", "detected_motions","power","office_CO2_concentration","Door","CO2_corridor","acoustic_pressure_dB"]], 
    data[["labelcopy"]], test_size = .3, random_state = 0)


# Implement the DT
def decision_tree(x_train, x_test, y_train, y_test,D):
    clf = tree.DecisionTreeClassifier(max_depth=D)
    clf = clf.fit(x_train, y_train)
    y_test_pred = clf.predict(x_test)
    accuracy = clf.score(x_test, y_test)
    print (accuracy)
    importance = clf.feature_importances_
    print ("Features importance", importance)
    indices = np.argsort(importance)
    plt.title("Feature Importances")
    plt.bar(range(len(indices)), importance[indices], color='b', align='center')
    plt.yticks(range(len(indices)), [x_train.columns.values[i] for i in indices])
    plt.xlabel("Relative Importance")
    with open("MyTree.dot", 'w') as file:
        tree.export_graphviz(clf, out_file=file)
    print(metrics.classification_report(y_test, y_test_pred,target_names=['level 0', 'level 1']))
    return y_test_pred



x_train, x_test, y_train, y_test = train_test_split(
    data[["Tin" , "Door", "detected_motions", "Tout", "humidity"]],
    data[['labelcopy']], test_size=.2, random_state=0)
y_pred_occupancy= decision_tree(x_train, x_test,y_train, y_test,5)



depth=[1,2,3,4, 5, 6, 7, 8, 9, 10, 11]
accuracy=[0.34,0.61,0.6,0.69,0.62,0.63, 0.65,0.64, 0.63, 0.69, 0.67]

plt.plot(depth,accuracy)
plt.show()
