## Importations

#import matplotlib.pyplot as plt
#import numpy as np
#from sklearn.model_selection import train_test_split
#from sklearn import tree
#from sklearn import metrics
import pandas as pd
import time
import datetime

## datetime

''' On crée une fonction qui permet de modifier nos fichiers csv afin de retirer la ponctuation qui nous gêne pour extraire les données '''

def stringdate_to_datetime(stringdatetime: str):
    if "." in stringdatetime:
        stringdatetime=stringdatetime.split(".")[0]
    else:
        stringdatetime=stringdatetime.split("Z")[0]
    return datetime.datetime.fromtimestamp(time.mktime(time.strptime(stringdatetime, '%Y-%m-%dT%H:%M:%S')))

## Lecture des fichiers
    
''' On crée une liste pour chaque capteur à partir de la lecture d'un fichier csv et de la fonction précédente '''

TV_power= pd.read_csv('C:/Users/matth/Documents/Projet 11/TV_power.csv', sep= ',')
TV_power["datetime"]=TV_power["time"].apply(stringdate_to_datetime)

Box_TV= pd.read_csv('C:/Users/matth/Documents/Projet 11/Box_TV.csv', sep= ',')
Box_TV["datetime"]=Box_TV["time"].apply(stringdate_to_datetime)

Bruit= pd.read_csv('C:/Users/matth/Documents/Projet 11/Bruit.csv', sep= ',')
Bruit["datetime"]=Bruit["time"].apply(stringdate_to_datetime)

Lumière= pd.read_csv('C:/Users/matth/Documents/Projet 11/Lumière.csv', sep= ',')
Lumière["datetime"]=Lumière["time"].apply(stringdate_to_datetime)

Luminosité= pd.read_csv('C:/Users/matth/Documents/Projet 11/Luminosité.csv', sep= ',')
Luminosité["datetime"]=Luminosité["time"].apply(stringdate_to_datetime)

Fenêtre= pd.read_csv('C:/Users/matth/Documents/Projet 11/Fenêtre.csv', sep= ',')
Fenêtre["datetime"]=Fenêtre["time"].apply(stringdate_to_datetime)

Humidité= pd.read_csv('C:/Users/matth/Documents/Projet 11/Humidité.csv', sep= ',')
Humidité["datetime"]=Humidité["time"].apply(stringdate_to_datetime)

Température= pd.read_csv('C:/Users/matth/Documents/Projet 11/Température.csv', sep= ',')
Température["datetime"]=Température["time"].apply(stringdate_to_datetime)

CO2= pd.read_csv('C:/Users/matth/Documents/Projet 11/CO2.csv', sep= ',')
CO2["datetime"]=CO2["time"].apply(stringdate_to_datetime)

## fusion des fichiers dans un tableau

''' Ici, on cherche à regrouper les listes précédentes dans un tableau afin de travailler avec un seul objet''' 

mergeData=[TV_power,Box_TV,Bruit,Lumière,Luminosité,Fenêtre,Humidité,Température,CO2]
result=pd.concat(mergeData, axis=1, join='inner')

## Trie des données par demie-heure

''' Le tableau présente des valeurs 'très différentes d'heures. On choisit de garder les informations toutes les demie-heures '''

TV_power.set_index('datetime',inplace=True)
print("isnull",TV_power.isnull().any())
TV_power.ffill()
newTV_power=TV_power.resample('30T').sum()
#print(newTV_power)

Box_TV.set_index('datetime',inplace=True)
print("isnull",Box_TV.isnull().any())
Box_TV.ffill()
newBox_TV=Box_TV.resample('30T').sum()
#print(newBox_TV)

Bruit.set_index('datetime',inplace=True)
print("isnull",Bruit.isnull().any())
Bruit.ffill()
newBruit=Bruit.resample('30T').sum()
#print(newBruit)


Lumière.set_index('datetime',inplace=True)
print("isnull",Lumière.isnull().any())
Lumière.ffill()
newLumière=Lumière.resample('30T').sum()
#print(newLumière)


Luminosité.set_index('datetime',inplace=True)
print("isnull",Luminosité.isnull().any())
Luminosité.ffill()
newLuminosité=Luminosité.resample('30T').sum()
#print(newLuminosité)


Fenêtre.set_index('datetime',inplace=True)
print("isnull",Fenêtre.isnull().any())
Fenêtre.ffill()
newFenêtre=Fenêtre.resample('30T').sum()
#print(newFenêtre)


Humidité.set_index('datetime',inplace=True)
print("isnull",Humidité.isnull().any())
Humidité.ffill()
newHumidité=Humidité.resample('30T').sum()
#print(newHumidité)


Température.set_index('datetime',inplace=True)
print("isnull",Température.isnull().any())
Température.ffill()
newTempérature=Température.resample('30T').sum()
#print(newTempérature)


CO2.set_index('datetime',inplace=True)
print("isnull",CO2.isnull().any())
CO2.ffill()
newCO2=CO2.resample('30T').sum()
#print(newCO2)

## Fusion des listes triées par demie-heure

''' De même on fusionne les données triées par demie-heure pour ecploiter un seul objet par la suite '''

mergeData2=[newTV_power,newBox_TV,newBruit,newLumière,newLuminosité,newFenêtre,newHumidité,newTempérature,newCO2]
result2=pd.concat(mergeData2, axis=1, join='inner')

## hours

''' On cherche désormais à créer une liste avec les heures de la journée à partir des valeurs de CO2 dans le but de créer notre liste occupancy '''

hours =[]
data_datetimes = pd.to_datetime(CO2.iloc[:,0],format='%Y-%m-%dT%H:%M:%S')
for dt in data_datetimes:
    hours.append(dt.hour)
CO2['hour']=hours

## Occupancy

''' On crée la liste occupancy qui fait la même taille que la liste heures. Le choix des valeurs dépend de nos hypothèses de départ '''

occupancy=[]
for i in range (len(hours)):
    if 7<=hours[i]<=8:
        occupancy.append(1)
    if 17<=hours[i]<=23:
        occupancy.append(1)
    if 12<=hours[i]<=13:
        occupancy.append(1)
    else:
        occupancy.append(0)

## Pertes d'énergie
        
''' on applique maintenant le scénario décrit dans le compte-rendu ''' 

window=newFenêtre["Fenêtre"]
Co2=newCO2["CO2"]
lyt=newLumière["Lumière"]
box_tv=newBox_TV["Box_TV"]
tv_power=newTV_power["TV_power"]
temperature=newTempérature["Température"]
pertedenergie=0

for i in range (len(result2)):
#    if window[i]==1 and Co2[i]<3000 and :
#        print('pertes d énegie car on l air n est pas sain',hours[i],'h')
    if lyt[i]==1 and occupancy[i]==0:
        pertedenergie +=1
        print('La lumiere est allumee mais il n y a personne',hours[i],'h')
    if tv_power[i]!=0 and box_tv[i]!=0 and occupancy[i]==0:
        pertedenergie +=1
        print('La télé et la box sont allumées mais il n y a personne à',hours[i],'h')
    if temperature[i]<20 and window[i]==1:
        pertedenergie +=1
        print('on devrait fermer la fenêtre pour ne pasa chauffer l extérieur à',hours[i],'h')

print ("Il y a ", pertedenergie, "occurences de perte d'énergie en une journée")
